/*  Tehnica RAII
    Resource Aquisition Is Initialization

*/

#include <iostream>
#include <vector>

template <class T>
class Vector {
public:
    Vector() : n {0}, ptr {nullptr}
    {}

    Vector(int n, const T& val = T()) : // achizitionarea resurselor la initializare
        n {n}, ptr {new T[n]}
    {
        for (int i = 0; i < n; ++i)
            ptr[i] = val;
        std::cout << __PRETTY_FUNCTION__ << '\n';
    }

    ~Vector()
    {
        if (ptr != nullptr)
        {
            delete[] ptr;      // eliberarea resurselor
        //    ptr = nullptr;
        }

        std::cout << __PRETTY_FUNCTION__ << '\n';
    }
// Tip membru
    using iterator = T*;

// Functii Membre

    iterator begin() const
    {
        return ptr;
    }

    iterator end() const
    {
        return ptr + n;
    }

private:
    int n;
    T *ptr;
};

int main()
{
    std::cout << "Prima instructiune din program\n";
    {
        Vector<int> v(10, -7);

        for (Vector<int>::iterator it = v.begin();
                it != v.end(); ++it)
                std::cout << *it << ' ';
        std::cout << '\n';
    }

    std::cout << "\nIesire din program";
}


